//
//  geometric_graph_test.cpp
//  SimpleProg
//
//  Created by kumada on 2013/08/20.
//  Copyright (c) 2013年 kumada. All rights reserved.
//

#include "geometric_graph_test.h"
#include "Vertex.h"
#include "Edge.h"
#include "Face.h"
#include "Body.h"
#include <iostream>

namespace
{
        void test_vertex()
        {
                using namespace geo;
                
                Vertex v{0, 0, 0};
                std::cout << get<0>(v) << " " << get<1>(v) << " " << get<2>(v) << std::endl;
                get<0>(v) = 100;
                std::cout << get<0>(v) << " " << get<1>(v) << " " << get<2>(v) << std::endl;
                
                Vertex u{1, 2, 0};
                const auto& p0 = v.get_point();
                const auto& p1 = u.get_point();
                typedef Vertex::Point Point;
                
                Point p2 = p0 + p1;
                Vertex w {p2};
                
                std::cout << get<0>(w) << " " << get<1>(w) << " " << get<2>(w) << std::endl;
        }
        
        void test_edge()
        {
//                Vertex sv {0, 0, 0};
//                Vertex ev {1, 1, 1};
//                
//                Edge e {};
//                e.set_start_vertex(&sv);
//                auto v = e.get_start_vertex();
//                auto& p = v->get_point();
//                p[0] = 1000;
//                std::cout << get<0>(sv) << " " << get<1>(sv) << " " << get<2>(sv) << std::endl;
                
        }
        
        void test_face()
        {
//                Vertex sv {0, 0, 0};
//                Vertex ev {1, 1, 1};
//                
//                Edge e {};
//                e.set_start_vertex(&sv);
//                auto v = e.get_start_vertex();
//                auto& p = v->get_point();
//                p[0] = 1000;
//                std::cout << get<0>(sv) << " " << get<1>(sv) << " " << get<2>(sv) << std::endl;
//
//                Face f {};
//                e.set_right_face(&f);
                
        }
        
        void test_body()
        {
                Body body {};
                
        }
}

void geometric_graph_test(int argc, char* argv[])
{
        test_vertex();
        test_edge();
        test_face();
        test_body();
}