//
//  Face.h
//  SimpleProg
//
//  Created by kumada on 2013/08/20.
//  Copyright (c) 2013年 kumada. All rights reserved.
//

#ifndef SimpleProg_Face_h
#define SimpleProg_Face_h

class Face
{
public:
        Face() = default;
        ~Face() = default;
        
        void set_edge(int e)
        {
                edge_index_ = e;
        }
        
        int get_edge() const
        {
                return edge_index_;
        }
        
        void set_next(int n)
        {
                next_index_ = n;
        }
        
        int get_next() const
        {
                return next_index_;
        }
        
        
private:
        int     edge_index_;
        int     next_index_;
        
        Face(const Face&) = delete;
        Face(Face&&) = delete;
        Face& operator=(const Face&) = delete;
        Face& operator=(Face&&) = delete;
};

#endif
